// Library file DELSEG.C (used to build LIBWAV.A)
// Written by:
// Daniel W. Lewis (dlewis@scu.edu)
// Computer Engineering Department
// Santa Clara University
// Revised Jan 2, 2015

#include "libwav.h"

AUDIO *DeleteSegment(AUDIO *source, unsigned frstndex, unsigned lastndex)
	{
	unsigned index, num_samples ;
	SAMPLE *sample ;

	_DelPointer(source) ;

	sample = &source->samples[frstndex] ;
	num_samples = lastndex - frstndex + 1 ;
	memcpy(sample, sample + num_samples, (source->num_samples - lastndex) * sizeof(SAMPLE)) ; 
	source->num_samples -= num_samples ;
	source = (AUDIO *) realloc(source, sizeof(AUDIO) + source->num_samples * sizeof(SAMPLE)) ;
	if (source == NULL) _Error("Error reallocating memory\n") ;

	_AddPointer(source) ;
	return source ;
	}
