// Library file INSSEG.C (used to build LIBWAV.A)
// Written by:
// Daniel W. Lewis (dlewis@scu.edu)
// Computer Engineering Department
// Santa Clara University
// Revised Jan 2, 2015

#include "libwav.h"

AUDIO *InsertSegment(AUDIO *dst, AUDIO *src, unsigned at)
	{
	unsigned index ;
	SAMPLE *sample ;

	_ChkPointer(src) ;
	_DelPointer(dst) ;

	if (src->sample_rate != dst->sample_rate)
		{
		_Error("Error: Audio files have different sample rates\n") ;
		}

	dst = (AUDIO *) realloc(dst, sizeof(AUDIO) + (dst->num_samples + src->num_samples) * sizeof(SAMPLE)) ;
	if (dst == NULL) _Error("Insufficient memory\n") ;

	sample = &dst->samples[at] ;
	memmove(sample + src->num_samples, sample, (dst->num_samples - at) * sizeof(SAMPLE)) ;
	memmove(sample, src->samples, src->num_samples * sizeof(SAMPLE)) ;
	dst->num_samples += src->num_samples ;

	_AddPointer(dst) ;
	return dst ;
	}
