// Include file WAV.H
// Written by:
// Daniel W. Lewis (dlewis@scu.edu)
// Computer Engineering Department
// Santa Clara University
// Revised Jan 2, 2015

#include <stdint.h>

typedef int16_t	SAMPLE ;

typedef struct
	{
	unsigned		sample_rate ;
	unsigned		num_samples ;
	SAMPLE			samples[0] ;
	} AUDIO ;

AUDIO *	NewAudio(unsigned samples, unsigned rate) ;
AUDIO *	ReadWAV16(char *filespec) ;
void	WriteWAV16(char *filespec, AUDIO *audio) ;
void	FreeAudio(AUDIO *audio) ;

AUDIO *	CopySegment(AUDIO *source, unsigned frstndex, unsigned lastndex) ;
AUDIO *	InsertSegment(AUDIO *target, AUDIO *segment, unsigned at) ;
AUDIO *	DeleteSegment(AUDIO *source, unsigned frstndex, unsigned lastndex) ;

