// File LIBWAV.H (used to build LIBWAV.A)
// Written by:
// Daniel W. Lewis (dlewis@scu.edu)
// Computer Engineering Department
// Santa Clara University
// Revised Jan 2, 2015

#include <stdio.h>
#include <stdarg.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>

#include "wav.h"

#pragma pack(1)    
typedef struct
	{
	uint32_t		id ;
	uint32_t		size ;
	} CHUNK_HDR ;

typedef struct
	{
	uint32_t		format ;
	} RIFF_INFO ;

typedef struct
	{
	uint16_t		format ;
	uint16_t		num_channels ;
	uint32_t		sample_rate ;
	uint32_t		byte_rate ;
	uint16_t		block_align ;
	uint16_t		bits_per_sample ;
	} FMT_INFO ;
#pragma pack()

#define PRIVATE static

void _Error(char *format, ...) ;
void _AddPointer(AUDIO *audio) ;
void _ChkPointer(AUDIO *audio) ;
void _DelPointer(AUDIO *audio) ;
