// Library file NEWAUDIO.C (used to build LIBWAV.A)
// Written by:
// Daniel W. Lewis (dlewis@scu.edu)
// Computer Engineering Department
// Santa Clara University
// Revised Jan 2, 2015

#include "libwav.h"

AUDIO *NewAudio(unsigned num_samples, unsigned sample_rate)
	{
	unsigned bytes = sizeof(AUDIO) + sizeof(SAMPLE) * num_samples ;
	AUDIO *audio = (AUDIO *) calloc(bytes, 1) ;
	if (audio == NULL) _Error("Insufficient memory to create new audio") ;

	audio->sample_rate	= sample_rate ;
	audio->num_samples	= num_samples ;

	_AddPointer(audio) ;
	return audio ;
	}

