// File NEWIMG.C (used to build LIBBMP.A)
// Written by:
// Daniel W. Lewis (dlewis@scu.edu)
// Computer Engineering Department
// Santa Clara University
// Revised Jan 15, 2015

#include "libbmp.h"

IMAGE *NewImage(unsigned rows, unsigned cols)
	{
	IMAGE *image = (IMAGE *) malloc(sizeof(IMAGE) + rows * sizeof(RGB *)) ;
	if (image == NULL) _Error("Insufficient memory to create image") ;
	int row ;

	for (row = 0; row < rows; row++)
		{
		image->pxlrow[row] = (RGB *) calloc(1, _BytesPerRow(cols)) ;
		if (image->pxlrow[row] == NULL) _Error("Insufficient memory to create image") ;
		}

	image->rows = rows ;
	image->cols = cols ;
	image->dpi = 72 ;

	_AddPointer(image) ;
	return image ;
	}
