// File RGB2HSV.C (used to build LIBBMP.A)
// Written by:
// Daniel W. Lewis (dlewis@scu.edu)
// Computer Engineering Department
// Santa Clara University
// Revised Jan 15, 2015

#include "libbmp.h"

HSV RGB2HSV(RGB *rgb)
	{
	unsigned red = rgb->red ;
	unsigned grn = rgb->grn ;
	unsigned blu = rgb->blu ;
	unsigned min, max ;
	int delta, degrees ;
	HSV hsv ;

	min = MIN(red, grn) ;	min = MIN(min, blu) ;
	max = MAX(red, grn) ;	max = MAX(max, blu) ;

	hsv.val = (100 * max + 128) / 255 ;

	if (max == 0)
		{
		hsv.sat = 0 ;	// if (s == 0) then
		hsv.hue = 0 ;	//    h = undefined
		return hsv ;
		}

	delta = max - min ;
	hsv.sat = (100 * delta + max/2) / max ;

	if (delta == 0)
		{
		hsv.hue = 0 ;
		return hsv ;
		}

	if (red == max)		degrees =   0 + (60 * ((int) grn - (int) blu) + delta/2) / delta ;	// magenta ... yellow
	else if (grn == max)	degrees = 120 + (60 * ((int) blu - (int) red) + delta/2) / delta ;	// yellow ... cyan
	else /*(blu == max)*/	degrees = 240 + (60 * ((int) red - (int) grn) + delta/2) / delta ;	// cyan ... magenta

	hsv.hue = (degrees + 360) % 360 ;

	return hsv ;
	}

